#ifndef SHADER_GL_H_
#define SHADER_GL_H_

#include "shader.h"

class ShaderGL : public Shader {
protected:
	/* bsz for vulkan, in opengl buf is 0 terminated */
	virtual bool create(char *buf, unsigned int bsz, const char *fname);

public:
	unsigned int sdr;

	ShaderGL();
	virtual ~ShaderGL();

	virtual void destroy() override;
};

class ShaderProgramGL : public ShaderProgram {
protected:
	unsigned int prog;
	bool is_linked;

public:
	ShaderProgramGL();
	virtual ~ShaderProgramGL();

	virtual bool link() override;
	virtual bool use() const override;
	virtual bool create() override;
	virtual void destroy() override;
	virtual void attach_shader(Shader *shader) override;

	virtual int get_uniform_location(const char *name) const override;

	virtual void set_uniformi(int location, int value) override;
	virtual void set_uniformi(int location, int x, int y) override;
	virtual void set_uniformi(int location, int x, int y, int z) override;
	virtual void set_uniformi(int location, int x, int y, int z, int w) override;

	virtual void set_uniformf(int location, float value) override;
	virtual void set_uniformf(int location, float x, float y) override;
	virtual void set_uniformf(int location, float x, float y, float z) override;
	virtual void set_uniformf(int location, float x, float y, float z, float w) override;

	virtual void set_uniform_matrix(int location, const Mat4 &mat) override;
};

#endif // SHADER_GL_H_