#ifndef SHADER_MANAGER_H_
#define SHADER_MANAGER_H_

#include <map>
#include <string>

#include "shader.h"

class ShaderManager {
private:
	std::map<std::string, Shader *> shaders;
	std::string path;

public:
	ShaderManager();
	~ShaderManager();

	void add_shader(Shader *sdr, const char *name);
	Shader *load_shader(const char *name, SType type);
	void delete_shaders();

	ShaderProgram *create_shader_program(const char *vname, const char *fname);

	void set_path(const char *path);
};

#endif // SHADER_MANAGER_H_